/**********************************************************************
*Author:	Fallenhobbit
*Date:		01/06/05
*Purpose:	This is just a small proggy that I used to write the
*macro library. It parses msvcrtproto.txt and writes out msvcrtmac.inc.
**********************************************************************/
#include <stdio.h>
#include <fstream>
#include <string>
using namespace std;

int main(void)
{
    char tmp1[2000];
    char outtxt[1000];
    char popstr[1000];
    char curtok[255]={0};
    char reqtok[255]={0};
    char intxt[255];
    char func[255];   
    char sep[]={" "};
    char *token=0;
    fstream filein("msvcrtproto.txt", ios::in);
    fstream fileout("msvcrtmac.inc", ios::out);
    int i;
    int pops;
    while(!filein.eof())
    {
        filein.getline(intxt,255);
        token=strtok(intxt,sep);
        if(!token)
        {
            continue;
        }
        strcpy(func,token);
        sprintf(outtxt,"m%s MACRO",token);
        fileout.write(outtxt,strlen(outtxt));
        outtxt[0]=0;
        popstr[0]=0;
        reqtok[0]=0;
        i=0;
        pops=0;
        while(1)
        {
            token=strtok(NULL,sep);
            if(token==NULL)
                break;
            if(!strcmp(token,"word"))
            {
                sprintf(curtok," %s%i:REQ,",token,i);
                strcat(reqtok,curtok);
                sprintf(curtok,"\n  mov bx,%s%i\n  push bx",token,i);
                ++pops;
            }
            else if(!strcmp(token,"dword"))
            {
                sprintf(curtok," %s%i:REQ,",token,i);
                strcat(reqtok,curtok);
                sprintf(curtok,"\n  mov ebx,%s%i\n  push ebx",token,i);
                ++pops;
            }
            else if(!strcmp(token,"qword"))
            {
                sprintf(curtok," %s%i:REQ,",token,i);
                strcat(reqtok,curtok);
                sprintf(curtok,"\n  lea ebx,%s%i\n  push [ebx+4]\n  push [ebx]",token,i);
                pops+=2;
            }
            if(curtok[0])
            {
                strcpy(tmp1,outtxt);
                sprintf(outtxt,"%s%s",curtok,tmp1);
                ++i;
                curtok[0]=0;
            }
        }
        for(int y=0;y<pops;y++)
        {
            strcat(popstr,"  pop ebx\n");
        }
        i=strlen(reqtok);
        if(i)
        {
            reqtok[(i-1)]=0;	//removes the extra ,
        }
        sprintf(tmp1,"%s\n  push ebx%s\n  call %s\n%s  pop ebx\nENDM\n\n",reqtok,outtxt,func,popstr);
        fileout.write(tmp1,strlen(tmp1));
    }
    filein.close();
    fileout.close();
    return 0;
}
